# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import pydantic_v1
from .api_key import ApiKey
from .connection import Connection


class User(pydantic_v1.BaseModel):
    user_id: typing.Optional[str] = None
    email: str
    api_keys: typing.Optional[typing.List[ApiKey]] = None
    index_ids: typing.Optional[typing.List[str]] = None
    metadata: typing.Optional[typing.Dict[str, typing.Any]] = None
    connections: typing.Optional[typing.List[Connection]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
